<?php

//******************************************************************************
//                     CLASSES TO GENERATE THE GRAPH
//******************************************************************************
//Just in case it would be needed
require_once('include.constants.php');
//JPGRAPH
require_once('jpgraph.php'); //JPGraph-Main

class bm_periodengrafik
{
  //Das JPGraph-Objekt
  var $graph_object;
  var $plot_data;
  var $graph_output_path;
	
	/*KONSTRUKTOR
	  Sets up the basic graph, the graph itself must be output with addplot
	  *PARAMETER*
	  $width	:Breite der Grafik (Pixel)
	  $height	:Hoehe der Grafik (Pixel)
	  //The derived class will set this itself
	  x_title	: X-Axistitle 
	  y_title 	: Y-Axistitle
	  main title: Main Title of the graph

	  Set:
	  - X Size
	  - X White Background
	  - X No Frame
	  - X Margins
	  - X Fonts
	  - X Scale
	*/
	function bm_periodengrafik ($width,$height)
	{
		// Code
	      $this->graph_object = new Graph($width,$height);
	      $this->graph_object->SetMarginColor('white');
	      $this->graph_object->SetScale("textlin");
	      $this->graph_object->SetFrame(false);
	      //Activate Antialiasing to make the graph look nice
		$this->graph_object->img->SetAntiAliasing();
	      //$this->graph_object->SetMargin(30,50,30,30);
	}//END konstruktor
  
	/* addplot
	Adds the actual plot to the graph.
	This class has to be programmed by the derived class to allow more flexible plot design.
	*/
	function addplot()
	{
	/*
    	... see above
      */
	}//END addplot
  
	/*createoutput
  	Ruft $this->graph->stroke(temp/$filename) auf, und erzeugt eine temporaere
  	Bilddatei auf der Serverfestplatte.
  	Diese kann dann in das PDF eingebunden werden, nachdem das geschehen ist,
  	kann mit releaseoutput die Datei wieder geloescht werden.
  	*PARAMETER*
  	$filename Der Datei*name* (nicht Pfad) mit dem die Datei gespeichert wird
  	*RUECKGABE*
  	Gibt einen String zurueck mit dem die temporaere Bilddatei angesprochen werden kann
	  	
	Calls $this->graph_object->stroke($this->graph_output_path), and creates a temporary Graphpicture
	file on the servers harddisk.
	This picture can then be embedded in the PDF. When that is done, the picture can be deleted with 
	releaseoutput.
	* PARAMETER * 
	$filename	: The FileNAME (not Path) the file has been saved with.
	* RETURN * 
	The path to the temporary picture/file.
	*/
	function createoutput($filename_prefix)
	{
  		$aux= new auxtools();
		//Create filename and save it to the graph_output_path variable in the object for use by releaseoutput
		$this->graph_output_path=BM_TEMPLATE_PNG_PATH.$filename_prefix.BM_TEMPLATE_FILENAME.'.png';
		//### DEBUG ###
		//$aux->debug_out($this->graph_output_path);
		//Output to servers harddisk
		$this->graph_object->stroke($this->graph_output_path);
	  	//Return the filename
		return $this->graph_output_path;
	}//END createoutput
  
	/* releaseoutput
  	Deletes a temporary image file created with createoutput before.
	It takes the path to the file to be deleted from the graph_output_path-variable set in createoutput
	* RETURN * 
	Returns TRUE if the deletion was successfull, else FALSE.
	*/
	function releaseoutput()
	{
	  	return (unlink($this->graph_output_path));
	}//END releaseoutput
  
  
	/* measure
	Is called by translate_X_array from the derived classes to judge the value coming from the mobile device
	* PARAMETER *
	$menstruationdata		: One Value from the data input of the mobile device
	* RETURN *
	0=BM_MEASURE_ZERO
	2,6 = BM_MEASURE_SURROUND
	3,5 = BM_MEASURE_MIDDLE (hier war der mittelpunkt/maximum der grafik)
	For every other value BM_MEASURE_ZERO will be returned
	*/
	function measure($menstruationdata)
	{
  	//debug
  	$aux=new auxtools();
  	//$aux->debug_out('measure called: '.$menstruationdata.' type: '.gettype($menstruationdata));
  	$menstruationdata=intval($menstruationdata);
  	//$aux->debug_out('measure intval: '.$menstruationdata.' type: '.gettype($menstruationdata));
  	if ($menstruationdata==0):
  		//$aux->debug_out('measure zero branch');
			return BM_MEASURE_ZERO;
  	elseif ($menstruationdata==3 or $menstruationdata==5):
  		//$aux->debug_out('measure 3 or 5 middle branch');
			return BM_MEASURE_MIDDLE;
		elseif ($menstruationdata==2 or $menstruationdata==6):
  		//$aux->debug_out('measure 2 or 6-surround branch');
			return BM_MEASURE_SURROUND;
  	else:
  		//$aux->debug_out('measure else branch');
			return BM_MEASURE_ZERO;
  	endif;
	}//END measure
  
}//END class periodengrafik

//### DEBUG ###
$deb=new auxtools();
//$backtrace=debug_backtrace();
//$deb->debug_out(__FILE__.' OK<br>'.'(in '.__FILE__.', Line: '.__LINE__.', Function: '.__FUNCTION__.')<br>');
?>